import { OperationDefaultArgs, Operation } from '../components/OperationUtils';
import { CommandConfigT } from '../components/CommandUtils';
import { DFData, DFViewerConfig, DFWhole } from '../components/DFViewerParts/DFWhole';
export declare const bakedOperationDefaults: OperationDefaultArgs;
export declare const bakedCommandConfig: CommandConfigT;
export declare const bakedOperations: Operation[];
export declare const histograms: {
    num_histo: {
        name: string;
        population: number;
    }[];
    bool_histo: ({
        name: string;
        false: number;
        true?: undefined;
        NA?: undefined;
    } | {
        name: string;
        true: number;
        false?: undefined;
        NA?: undefined;
    } | {
        name: string;
        NA: number;
        false?: undefined;
        true?: undefined;
    })[];
    NA_Only: {
        name: string;
        NA: number;
    }[];
    simple_catgeorical: {
        name: number;
        cat_pop: number;
    }[];
    categorical_histo: ({
        name: string;
        cat_pop: number;
        unique?: undefined;
        NA?: undefined;
    } | {
        name: string;
        unique: number;
        cat_pop?: undefined;
        NA?: undefined;
    } | {
        name: string;
        NA: number;
        cat_pop?: undefined;
        unique?: undefined;
    })[];
    categorical_histo_lt: ({
        name: string;
        cat_pop: number;
        NA?: undefined;
        unique?: undefined;
        longtail?: undefined;
    } | {
        name: string;
        NA: number;
        cat_pop?: undefined;
        unique?: undefined;
        longtail?: undefined;
    } | {
        name: string;
        unique: number;
        longtail: number;
        cat_pop?: undefined;
        NA?: undefined;
    })[];
    all_unique: {
        name: string;
        unique: number;
    }[];
    unique_na: ({
        name: string;
        unique: number;
        NA?: undefined;
    } | {
        name: string;
        NA: number;
        unique?: undefined;
    })[];
    unique_continuous: ({
        name: string;
        population: number;
        unique?: undefined;
    } | {
        name: string;
        unique: number;
        population?: undefined;
    })[];
    unique_continuous_scaled: ({
        name: string;
        population: number;
        unique?: undefined;
    } | {
        name: string;
        unique: number;
        population?: undefined;
    })[];
    unique_continuous_scaled_50: ({
        name: string;
        population: number;
        unique?: undefined;
    } | {
        name: string;
        unique: number;
        population?: undefined;
    })[];
    start_station_categorical: {
        name: string;
        cat_pop: number;
    }[];
};
export declare const foo: DFWhole;
export declare const stringIndexDf: DFWhole;
export declare const tableDf: DFWhole;
export declare const dfviewer_config_no_pinned: DFViewerConfig;
export declare const summaryDfForTableDf: DFData;
export declare const realSummaryTableData: DFData;
export declare const realSummaryConfig: DFViewerConfig;
