"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Commands = exports.OperationViewer = exports.OperationAdder = exports.OperationsList = void 0;
const react_1 = __importStar(require("react"));
const lodash_1 = __importDefault(require("lodash"));
const utils_1 = require("./utils");
const bakedOperationDefaults_1 = require("./bakedOperationDefaults");
const OperationDetail_1 = require("./OperationDetail");
const ag_grid_react_1 = require("ag-grid-react"); // the AG Grid React Component
const utils_2 = require("./utils");
require("ag-grid-community/styles/ag-grid.css");
require("ag-grid-community/styles/ag-theme-alpine.css");
const staticData_1 = require("../baked_data/staticData");
const getColumns = (passedOperations) => lodash_1.default.map(Array.from(passedOperations.entries()), ([index, element]) => {
    const name = element[0]['symbol'];
    const key = name + index.toString();
    const column = { field: key, headerName: name }; // width: 20, maxWidth: 60};
    return column;
});
const OperationsList = ({ operations, activeKey, setActiveKey, }) => {
    const rowElements = lodash_1.default.map(Array.from(operations.entries()), ([index, element]) => {
        const name = element[0]['symbol'];
        const key = name + index.toString();
        const rowEl = {};
        rowEl[key] = element[2];
        return rowEl;
    });
    const rows = [lodash_1.default.merge({}, ...rowElements)];
    const columns = getColumns(operations);
    const styledColumns = (0, utils_2.updateAtMatch)(lodash_1.default.clone(columns), activeKey || '___never', {
        cellStyle: { background: 'var(--ag-range-selection-background-color-3)' },
    }, { cellStyle: {} });
    const gridOptions = {
        rowSelection: 'single',
        headerHeight: 30,
        onCellClicked: (event) => {
            const colName = event.column.getColId();
            setActiveKey(colName);
        },
    };
    return (react_1.default.createElement("div", { style: { height: 78, width: 1000 }, className: "ag-theme-alpine" },
        react_1.default.createElement(ag_grid_react_1.AgGridReact, { gridOptions: gridOptions, rowData: rows, columnDefs: styledColumns })));
};
exports.OperationsList = OperationsList;
const OperationAdder = ({ column, addOperationCb, defaultArgs, }) => {
    const addOperationByName = (localOperationName) => {
        return () => {
            const defaultOperation = defaultArgs[localOperationName];
            addOperationCb((0, utils_1.replaceInArr)(defaultOperation, 'col', column));
        };
    };
    return (react_1.default.createElement("div", { className: "operation-adder" },
        react_1.default.createElement("span", { className: 'column-name' },
            " Column: ",
            column),
        react_1.default.createElement("fieldset", null, lodash_1.default.keys(defaultArgs).map((optionVal) => (react_1.default.createElement("button", { key: optionVal, onClick: addOperationByName(optionVal) },
            ' ',
            optionVal,
            ' '))))));
};
exports.OperationAdder = OperationAdder;
const OperationViewer = ({ operations, setOperations, activeColumn, allColumns, commandConfig, }) => {
    const operationObjs = lodash_1.default.map(Array.from(operations.entries()), ([index, element]) => {
        const name = element[0]['symbol'];
        const key = name + index.toString();
        const rowEl = {};
        rowEl[key] = element;
        return rowEl;
    });
    //why am I doing this? probably something so I gauruntee a clean dict
    const operationDict = lodash_1.default.merge({}, ...operationObjs);
    const idxObjs = lodash_1.default.map(Array.from(operations.entries()), ([index, element]) => {
        const name = element[0]['symbol'];
        const key = name + index.toString();
        const rowEl = {};
        rowEl[key] = index;
        return rowEl;
    });
    const keyToIdx = lodash_1.default.merge({}, ...idxObjs);
    // previously was null
    const [activeKey, setActiveKey] = (0, react_1.useState)('');
    function getSetOperation(key) {
        return (newOperation) => {
            const index = keyToIdx[key];
            const nextOperations = operations.map((c, i) => {
                if (i === index) {
                    return newOperation;
                }
                else {
                    return c;
                }
            });
            setOperations(nextOperations);
        };
    }
    function getDeleteOperation(key) {
        return () => {
            const index = keyToIdx[key];
            const nextOperations = operations.map((c, i) => {
                if (i === index) {
                    return undefined;
                }
                else {
                    return c;
                }
            });
            setActiveKey('');
            setOperations(lodash_1.default.filter(nextOperations));
        };
    }
    const addOperation = (newOperation) => {
        const newOperationArr = [...operations, newOperation];
        setOperations(newOperationArr);
        const newOperationKey = getColumns(newOperationArr)[newOperationArr.length - 1].field;
        if (newOperationKey !== undefined) {
            setActiveKey(newOperationKey);
        }
    };
    const { argspecs, defaultArgs } = commandConfig;
    return (react_1.default.createElement("div", { className: "command-viewer" },
        react_1.default.createElement(exports.OperationAdder, { column: activeColumn, addOperationCb: addOperation, defaultArgs: defaultArgs }),
        react_1.default.createElement("div", { className: "operations-box" },
            react_1.default.createElement("h4", null, " Operations "),
            react_1.default.createElement(exports.OperationsList, { operations: operations, activeKey: activeKey, setActiveKey: setActiveKey })),
        activeKey && (react_1.default.createElement(OperationDetail_1.OperationDetail, { command: operationDict[activeKey], setCommand: getSetOperation(activeKey), deleteCB: getDeleteOperation(activeKey), columns: allColumns, commandPatterns: argspecs }))));
};
exports.OperationViewer = OperationViewer;
const Commands = () => {
    const [c, setC] = (0, react_1.useState)(staticData_1.bakedOperations);
    const [commandConfig, setCommandConfig] = (0, react_1.useState)(bakedOperationDefaults_1.bakedCommandConfig);
    (0, react_1.useEffect)(() => {
        fetch('http://localhost:5000/dcf/command-config').then((response) => __awaiter(void 0, void 0, void 0, function* () {
            setCommandConfig(yield response.json());
        }));
    }, []);
    return (react_1.default.createElement("div", { style: { width: '100%', height: '100%' } },
        react_1.default.createElement(exports.OperationViewer, { operations: c, setOperations: setC, activeColumn: 'new-column2', allColumns: ['foo-col', 'bar-col', 'baz-col'], commandConfig: commandConfig }),
        react_1.default.createElement("code", { style: { fontSize: '1em', textAlign: 'left' } },
            ' ',
            JSON.stringify(c, null, '\t\n\r'),
            ' ')));
};
exports.Commands = Commands;
//# sourceMappingURL=Operations.js.map